<?php
/*
 * Creastyle
 *
 * A simple ticket management system.
 *
 * @package		Creastyle
 * @author		Creastyle
 * @link		http://www.creastyle.fr
 * @link		http://www.creastyle.fr
 */

class Tickets extends CI_Controller {

	function __construct() {
		parent::__construct();
		// Validate login
		$this -> Admin -> _CheckLogin();
		$this -> data['title'] = 'Tickets';
		$this -> load -> model("Tickets_model", 'Tickets');
		$this -> load -> model("Emails");
		$this -> data['isadmin'] = $this -> Admin -> IsAdmin();
		$this -> data['staff'] = $this -> Admin -> GetStaffDetails($this -> session -> userdata('staffid'));

	}

	function index() {
		$status = urldecode($this -> uri -> segment(4));
		
		
		$this -> data['tickets'] = $this -> Tickets -> ListTickets($status);

		// If there is only 1 ticket, view that ticket content instead of listing.
		// This will help the staff to see the ticket ( eg, open ticket ) without listing
		// the ticket.
		if (sizeof($this -> data['tickets']) == 1) {
			$ticketid = $this -> data['tickets'][0]['id'];
			$this -> view($ticketid);

		} else
			$this -> load -> admin_template('tickets', $this -> data);
	}

	function view($ticketid = '') {
		if (!$ticketid)
			$ticketid = $this -> uri -> segment('4');

		$this -> data['ticketid'] = $ticketid;
		$this -> data['ticket'] = $this -> Tickets -> GetTicketDetails($ticketid);
		$this -> data['replies'] = $this -> Tickets -> GetTicketReplies($ticketid);
		$this -> data['statuses'] = $this -> Tickets -> GetStatuses();
		$this -> data['additional'] = $this -> Tickets -> GetAdditionaFields($ticketid);
		$this -> load -> admin_template('ticket_view', $this -> data);
	}

	function reply() {
		$ticketid = $this -> input -> post('ticketid');
		$status = $this -> input -> post('status');

		if (!$status)
			$status = 'close';

		$this -> form_validation -> set_rules('reply', 'Reply', 'trim|required');

		$reply = $this -> input -> post('reply');
		if ($this -> form_validation -> run() == FALSE) {
			$this -> view($ticketid);
		} else {
			$data['ticketid'] = $ticketid;
			$data['body'] = $reply;
			$data['replier'] = 'staff ';
			$data['replierid'] = $this -> session -> userdata('staffid');
			$this -> Tickets -> AddReply($data, $status);
			$this -> data['success'] = "Une réponse a été ajoutée";

			// Send mail to the customer about ticket udpate
			$result = $this -> Tickets -> GetTicketDetails($ticketid);
			$clienthash = $result['hash'];
			$email = $result['email'];
			$subject = "Ticket #$ticketid Répondu";
			$companyname = $this -> Emails -> GetSetting('companyname');
			$status = ucfirst($status);

			$link = site_url() . '/tickets/viewticket/' . $clienthash . '/' . $ticketid;

			$body = "
					Cher $email,<br><br>
					
					Notre support a répondu à votre ticket.<br><br> 
					
					Numéro du ticket : #$ticketid <br>
					Statut : $status<br><br>
					
					Pour voir la réponse et ajouter des commentaires supplémentaires, cliquez sur le lien ci-dessous.<br><br>
					
					<a href=\"$link\">$link</a> <br><br>
					
					Note: Ne répondez pas à cet email car votre réponse serait perdue.<br><br>
					Cordialement<br>
					$companyname
					";

			$this -> Emails -> SendMail($email, $subject, $body);
			$this -> view($ticketid);
		}

	}

	function close() {
		$referer = $_SERVER["HTTP_REFERER"];
		$ticketid = $this -> uri -> segment('4');
		$this -> Tickets -> CloseTicket($ticketid);
		redirect($referer);
	}

	function delete() {
		$referer = $_SERVER["HTTP_REFERER"];
		$ticketid = $this -> uri -> segment('4');
		$this -> Tickets -> DeleteTicket($ticketid);
		redirect($referer);
	}

	function viewattachment() {
		$name = $this -> uri -> segment('4');

		$file = "./attachments/$name";

		if (file_exists($file)) {
			header("Content-Description: File Transfer");
			header("Content-Type: application/octet-stream");
			header("Content-Disposition: attachment; filename=\"$name\"");
			readfile($file);
		}
		else {
			echo "Error downloading file. File not found!" ;
		}

	}

}
